import type { Locator, PlaywrightTestArgs, TestFixture } from '@playwright/test';
import type { Config, LocatorQueries as Queries } from '../types';
declare const options: {
    [k: string]: readonly [string | number, {
        readonly option: true;
    }];
};
declare const queriesFixture: TestFixture<Queries, PlaywrightTestArgs>;
declare const within: (locator: Locator) => Queries;
declare const registerSelectorsFixture: [
    TestFixture<void, PlaywrightTestArgs>,
    {
        scope: 'worker';
        auto?: boolean;
    }
];
declare const installTestingLibraryFixture: [
    TestFixture<void, PlaywrightTestArgs & Config>,
    {
        scope: 'test';
        auto?: boolean;
    }
];
export { installTestingLibraryFixture, options, queriesFixture, registerSelectorsFixture, within };
export type { Queries };
