"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.within = exports.registerSelectorsFixture = exports.queriesFixture = exports.options = exports.installTestingLibraryFixture = void 0;
const test_1 = require("@playwright/test");
const common_1 = require("../../common");
const helpers_1 = require("../helpers");
const helpers_2 = require("./helpers");
const queryNames = common_1.queryNames.filter(helpers_2.isNotFindQuery);
const defaultConfig = { testIdAttribute: 'data-testid', asyncUtilTimeout: 1000 };
const options = Object.fromEntries(Object.entries(defaultConfig).map(([key, value]) => [key, [value, { option: true }]]));
exports.options = options;
const queriesFor = (pageOrLocator) => queryNames.reduce((rest, query) => (Object.assign(Object.assign({}, rest), { [query]: (...args) => pageOrLocator.locator(`${(0, helpers_2.queryToSelector)(query)}=${JSON.stringify(args, helpers_1.replacer)}`) })), {});
const queriesFixture = ({ page }, use) => __awaiter(void 0, void 0, void 0, function* () { return use(queriesFor(page)); });
exports.queriesFixture = queriesFixture;
const within = (locator) => queriesFor(locator);
exports.within = within;
const engine = () => ({
    query(root, selector) {
        const args = JSON.parse(selector, window.__testingLibraryReviver);
        if ((0, helpers_2.isAllQuery)(queryName))
            throw new Error(`PlaywrightTestingLibrary: the plural '${queryName}' was used to create this Locator`);
        // @ts-expect-error
        const result = window.TestingLibraryDom[queryName](root, ...args);
        return result;
    },
    queryAll(root, selector) {
        const testingLibrary = window.TestingLibraryDom;
        const args = JSON.parse(selector, window.__testingLibraryReviver);
        // @ts-expect-error
        const result = testingLibrary[queryName](root, ...args);
        if (!result)
            return [];
        return Array.isArray(result) ? result : [result];
    },
});
const registerSelectorsFixture = [
    ({}, use) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            yield Promise.all(queryNames.map((name) => __awaiter(void 0, void 0, void 0, function* () {
                return test_1.selectors.register((0, helpers_2.queryToSelector)(name), `(${engine.toString().replace(/queryName/g, `"${name}"`)})()`);
            })));
        }
        catch (error) {
            // eslint-disable-next-line no-console
            console.error('PlaywrightTestingLibrary: failed to register Testing Library functions\n', error);
        }
        yield use();
    }),
    { scope: 'worker', auto: true },
];
exports.registerSelectorsFixture = registerSelectorsFixture;
const installTestingLibraryFixture = [
    ({ context, asyncUtilTimeout, testIdAttribute }, use) => __awaiter(void 0, void 0, void 0, function* () {
        yield context.addInitScript(yield (0, helpers_2.buildTestingLibraryScript)({ config: { asyncUtilTimeout, testIdAttribute } }));
        yield use();
    }),
    { scope: 'test', auto: true },
];
exports.installTestingLibraryFixture = installTestingLibraryFixture;
//# sourceMappingURL=fixtures.js.map